///////////////////////////////////////////////////////////////////////////////////
// Category: Explicit
///////////////////////////////////////////////////////////////////////////////////
/**
 * 1. Sqrt(x) [69]
 *
 * Implement int sqrt(int x).
 * Compute and return the square root of x.
 * x is guaranteed to be a non-negative integer.
 * @example
 *     Input: 4
 *     Output: 2
 * @endexample
 * @example
 *     Input: 8
 *     Output: 2
 *     Explanation: The square root of 8 is 2.82842..., and since we
 *     want to return an integer, the decimal part will be truncated.
 * @endexample
 */
int mySqrt(int x);

// --------------------------------------------------------------------------------
/**
 * 2. Search Insert Position [35]
 *
 * Given a sorted array and a target value, return the index if the target is found.
 * If not, return the index where it would be if it were inserted in order.
 * You may assume no duplicates in the array.
 * @example
 *     Input: [1,3,5,6], 5
 *     Output: 2
 * @endexample
 * @example
 *     Input: [1,3,5,6], 2
 *     Output: 1
 * @endexample
 * @example
 *     Input: [1,3,5,6], 7
 *     Output: 4
 * @endexample
 * @example
 *     Input: [1,3,5,6], 0
 *     Output: 0
 * @endexample
 */
int searchInsert(std::vector<int>& nums, int target);

// --------------------------------------------------------------------------------
/**
 * 3. Search for a Range [34]
 *
 * Given an array of integers sorted in ascending order, find the starting
 * and ending position of a given target value.
 * Your algorithm's runtime complexity must be in the order of O(log n).
 * If the target is not found in the array, return [-1, -1].
 * @example
 *     Given [5, 7, 7, 8, 8, 10] and target value 8,
 *     return [3, 4].
 * @endexample
 */
std::vector<int> searchRange(std::vector<int>& nums, int target);

// --------------------------------------------------------------------------------
/**
 * 4. Search in Rotated Sorted Array [33]
 *
 * Suppose an array sorted in ascending order is rotated at some pivot unknown to you beforehand.
 * (i.e., 0 1 2 4 5 6 7 might become 4 5 6 7 0 1 2).
 * You are given a target value to search. If found in the array return its index, otherwise return -1.
 * You may assume no duplicate exists in the array.
 */
int search(std::vector<int>& A, int target);

// --------------------------------------------------------------------------------
/**
 * 5. Search in Rotated Sorted Array II [81]
 *
 * What if duplicates are allowed?
 * Would this affect the run-time complexity? How and why?
 * Suppose an array sorted in ascending order is rotated at
 * some pivot unknown to you beforehand.
 * Write a function to determine if a given target is in the array.
 * The array may contain duplicates.
 */
bool search(std::vector<int>& A, int target);

// --------------------------------------------------------------------------------
/**
 * 6. Find Minimum in Rotated Sorted Array [153]
 *
 * Suppose an array sorted in ascending order is rotated
 * at some pivot unknown to you beforehand.
 * (i.e., 0 1 2 4 5 6 7 might become 4 5 6 7 0 1 2).
 * Find the minimum element.
 * You may assume no duplicate exists in the array.
 */
int findMin(std::vector<int>& nums);

// --------------------------------------------------------------------------------
/**
 * 7. Find Minimum in Rotated Sorted Array II [154]
 *
 * What if duplicates are allowed?
 * Would this affect the run-time complexity? How and why?
 * Suppose an array sorted in ascending order is rotated
 * at some pivot unknown to you beforehand.
 * (i.e., 0 1 2 4 5 6 7 might become 4 5 6 7 0 1 2).
 * Find the minimum element.
 * The array may contain duplicates.
 */
int findMin(std::vector<int>& nums);

// --------------------------------------------------------------------------------
/**
 * 8. Find Peak Element [162]
 *
 * A peak element is an element that is greater than its neighbors.
 * Given an input array where num[i] != num[i+1],
 * find a peak element and return its index.
 * The array may contain multiple peaks, in that case
 * return the index to any one of the peaks is fine.
 * You may imagine that num[-1] = num[n] = -Inf.
 * For example, in array [1, 2, 3, 1], 3 is a peak element
 * and your function should return the index number 2.
 * Note:
 * Your solution should be in logarithmic complexity.
 */
int findPeakElement(std::vector<int>& nums);

// --------------------------------------------------------------------------------
/**
 * 9. H-Index II [275]
 *
 * Follow up for H-Index: What if the citations array is sorted in ascending order?
 * Could you optimize your algorithm?
 */
int hIndex(std::vector<int>& citations);

// --------------------------------------------------------------------------------
/**
 * 10. First Bad Version [278]
 *
 * You are a product manager and currently leading a team to develop a new product.
 * Unfortunately, the latest version of your product fails the quality check.
 * Since each version is developed based on the previous version,
 * all the versions after a bad version are also bad.
 * Suppose you have n versions [1, 2, ..., n] and you want to find out the first bad one,
 * which causes all the following ones to be bad.
 * You are given an API bool isBadVersion(version) which will return
 * whether version is bad. Implement a function to find the first bad version.
 * You should minimize the number of calls to the API.
 */

// Forward declaration of isBadVersion API.
bool isBadVersion(int version);

int firstBadVersion(int n);

// --------------------------------------------------------------------------------
/**
 * 11. Guess Number Higher or Lower [374]
 *
 * We are playing the Guess Game. The game is as follows:
 * I pick a number from 1 to n. You have to guess which number I picked.
 * Every time you guess wrong, I'll tell you whether the number is higher or lower.
 * You call a pre-defined API guess(int num) which returns 3 possible results (-1, 1, or 0):
 *   -1 : My number is lower
 *    1 : My number is higher
 *    0 : Congrats! You got it!
 * @example
 *     n = 10, I pick 6.
 *     Return 6.
 * @endexample
 */

// Forward declaration of guess API.
// @param num, your guess
// @return -1 if my number is lower, 1 if my number is higher, otherwise return 0
int guess(int num);

int guessNumber(int n);

// --------------------------------------------------------------------------------
/**
 * 12. Median of Two Sorted Arrays [4]
 *
 * There are two sorted arrays nums1 and nums2 of size m and n respectively.
 * Find the median of the two sorted arrays.
 * The overall run time complexity should be O(log (m+n)).
 * @example
 *     nums1 = [1, 3]
 *     nums2 = [2]
 *     The median is 2.0
 * @endexample
 * @example
 *     nums1 = [1, 2]
 *     nums2 = [3, 4]
 *     The median is (2 + 3)/2 = 2.5
 * @endexample
 */
double findMedianSortedArrays(std::vector<int>& nums1, std::vector<int>& nums2);





///////////////////////////////////////////////////////////////////////////////////
// Category: Matrix
///////////////////////////////////////////////////////////////////////////////////
/**
 * 1. Search a 2D Matrix [74]
 *
 * Write an efficient algorithm that searches for a value in an m x n matrix.
 * This matrix has the following properties:
 *   Integers in each row are sorted from left to right.
 *   The first integer of each row is greater than the last integer of the previous row.
 * @example
 *     Consider the following matrix:
 *     [
 *       [1,   3,  5,  7],
 *       [10, 11, 16, 20],
 *       [23, 30, 34, 50]
 *     ]
 *     Given target = 3, return true.
 * @endexample
 */
bool searchMatrix(std::vector<std::vector<int> >& matrix, int target);

// --------------------------------------------------------------------------------
/**
 * 2. Search a 2D Matrix II [240]
 *
 * Write an efficient algorithm that searches for a value in an m x n matrix.
 * This matrix has the following properties:
 *   Integers in each row are sorted in ascending from left to right.
 *   Integers in each column are sorted in ascending from top to bottom.
 * @example
 *     [
 *       [ 1,  4,  7, 11, 15],
 *       [ 2,  5,  8, 12, 19],
 *       [ 3,  6,  9, 16, 22],
 *       [10, 13, 14, 17, 24],
 *       [18, 21, 23, 26, 30]
 *     ]
 *     Given target = 5, return true.
 *     Given target = 20, return false.
 * @endexample
 */
bool searchMatrix(std::vector<std::vector<int> >& matrix, int target);

// --------------------------------------------------------------------------------
/**
 * 3. Kth Smallest Element in a Sorted Matrix [378]
 *
 * Given a n x n matrix where each of the rows and columns are sorted
 * in ascending order, find the kth smallest element in the matrix.
 * Note that it is the kth smallest element in the sorted order,
 * not the kth distinct element.
 * @example
 *     matrix = [
 *        [ 1,  5,  9],
 *        [10, 11, 13],
 *        [12, 13, 15]
 *     ],
 *     k = 8,
 *     return 13.
 * @endexample
 * Note:
 * You may assume k is always valid, 1 <= k <= n^2.
 */
int kthSmallest(std::vector<std::vector<int> >& matrix, int k);





///////////////////////////////////////////////////////////////////////////////////
// Category: Implicit
///////////////////////////////////////////////////////////////////////////////////
/**
 * 1. Longest Increasing Subsequence [300]
 *
 * Given an unsorted array of integers, find the length of longest increasing subsequence.
 * @example
 *     Given [10, 9, 2, 5, 3, 7, 101, 18],
 *     The longest increasing subsequence is [2, 3, 7, 101], therefore the length is 4.
 * @endexample
 * Note that there may be more than one LIS combination, it is only necessary for you
 * to return the length. Your algorithm should run in O(n^2) complexity.
 * Follow up:
 * Could you improve it to O(n log n) time complexity?
 */
int lengthOfLIS(std::vector<int>& nums);

// --------------------------------------------------------------------------------
/**
 * 2. Split Array Largest Sum [410]
 *
 * Given an array which consists of non-negative integers and an integer m,
 * you can split the array into m non-empty continuous subarrays.
 * Write an algorithm to minimize the largest sum among these m subarrays. 
 * @example
 *     Input:
 *     nums = [7,2,5,10,8]
 *     m = 2
 *     Output:
 *     18
 *     Explanation:
 *     There are four ways to split nums into two subarrays.
 *     The best way is to split it into [7,2,5] and [10,8],
 *       where the largest sum among the two subarrays is only 18.
 * @endexample
 * Note:
 * If n is the length of array, assume the following constraints are satisfied: 
 * 1. 1 <= n <= 1000;
 * 2. 1 <= m <= min(50, n).
 */
int splitArray(std::vector<int>& nums, int m);

// --------------------------------------------------------------------------------
/**
 * 3. Preimage Size of Factorial Zeroes Function [793]
 *
 * Let f(x) be the number of zeroes at the end of x!. (Recall that
 * x! = 1 * 2 * 3 * ... * x, and by convention, 0! = 1.)
 * For example, f(3) = 0 because 3! = 6 has no zeroes at the end,
 * while f(11) = 2 because 11! = 39916800 has 2 zeroes at the end.
 * Given K, find how many non-negative integers x have the
 * property that f(x) = K.
 * @example
 *     Input: K = 0
 *     Output: 5
 *     Explanation: 0!, 1!, 2!, 3!, and 4! end with K = 0 zeroes.
 * @endexample
 * @example
 *     Input: K = 5
 *     Output: 0
 *     Explanation: There is no x such that x! ends in K = 5 zeroes.
 * @endexample
 * Note:
 * K will be an integer in the range [0, 10^9].
 */
int preimageSizeFZF(int K);
